#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "sys.h"
#include "usart.h"
#include "timer.h"

#include "uart_adapt.h"
#include "ring.h"


#define	MEM_ALLOC	malloc
#define	MEM_FREE	free

#define	UART_READ_TIMEOUT	500
#define	UART_FRAME_TIMEOUT	20



static ring_t *rxRing;
static uint32_t readTimeOut;
static uint32_t frameTimeOut;


void uart_rxIrqCallBack(u8 val)
{
	frameTimeOut = UART_FRAME_TIMEOUT;
	ring_buffer_write(rxRing, &val, 1);
}

void time_IrqCallBack()
{
	if(readTimeOut)readTimeOut--;
	if(frameTimeOut)frameTimeOut--;
}

int uart_creat()
{
	rxRing = ring_buffer_init(1024, 1);
	readTimeOut = 0;
	frameTimeOut = 0;
	TIM3_Int_Init(9,7199);//10KhzļƵʣ9Ϊ1ms 
	uart_init(115200);
	
	return 0;
}

int uart_read(u8 *buf, u32 len)
{
	u32 bytes = 0;
	readTimeOut = UART_READ_TIMEOUT;
	//frameTimeOut = UART_FRAME_TIMEOUT;
	while(readTimeOut && (bytes != len)){
		INTX_DISABLE();//رж
		if(!frameTimeOut && ring_buffer_available(rxRing)){
			INTX_ENABLE();//ж
			bytes += ring_buffer_read(rxRing, &buf[bytes], len - bytes);
			return bytes;
		}
		INTX_ENABLE();//ж
	}
	
	return bytes;
	
}


int uart_write(u8 *buf, u32 len)
{
	int i;
	for(i = 0; i< len ;i++){
		USART_SendData(USART1, (uint8_t) buf[i]);

		while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET) {}	
	}
	return len;
}

